/*
 * Copyright (c) 2020 Raspberry Pi (Trading) Ltd.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#include "pico.h"

// do not put align in here as it is used mid function sometimes
regular_func MACRO x
    PUBLIC x
    THUMB
x:
    ENDM

regular_func_with_section MACRO x
    SECTION .text:CODE(2)
    regular_func x
    ENDM

// do not put align in here as it is used mid function sometimes
wrapper_func MACRO x
    regular_func WRAPPER_FUNC_NAME(x)
    ENDM

__pre_init MACRO func, priority_string
    SECTION .preinit_array.##priority_string
    ALIGN 2
    DC32 func
    ENDM

